var HttpHeader = require('../lib/http-header').HttpHeader;

// var __toks = {};
// __toks[SP] = "SP";
// __toks[CR] = "CR";
// __toks[LF] = "LF";
// var getToken = function(charCode) {
//   var res = __toks[charCode];
//   return res == null ? String.fromCharCode(charCode) : res;
// }

var test = function() {
  var parser = new HttpHeader();
  var buff = new Buffer("akey: avalue\r\na2ndkey: a2ndvalue\r\n\r\n");

  var res = parser.parseHeaders(buff);

  buff = new Buffer("HTTP/1.1 200 OK\r\n");
  res = parser.parseStartLine(buff);

  buff = new Buffer("GET /path/to/stuff HTTP/1.1\r\n");
  res = parser.parseStartLine(buff);

  buff = new Buffer("HTTP/1.1 200 OK\r\nServer: nginx/0.7.62\r\nDate: Mon, 22 Jul 2013 18:39:46 GMT\r\nContent-Type: text/html; charset=utf-8\r\nConnection: keep-alive\r\nPragma: no-cache\r\nCache-Control: no-cache\r\nX-FRAME-OPTIONS: DENY\r\nSet-Cookie: csrf_token=c1fb3cd0ab7509904daf7b61ec32f07d; expires=\"Mon, 22-Jul-2013 18:57:52 GMT\"; Max-Age=600; Path=/\r\nSet-cookie: metrics=b5ed23a3aed87510d21ad25c2ca2908809596888493698ed9025467b83c240d0f42f7168; Path=/\r\nContent-Length: 575\r\n\r\n");


  var count = 100000;
  console.time("parsing-response-header-"+count);
  for (var i = 0; i < count; i++) {
    var header = new HttpHeader(buff);
  }
  console.timeEnd("parsing-response-header-"+count);

  try {
    header.set('code', 418);
    header.set('reason', "I'm a teapot");
  } catch (e) {
    console.log(e);
  }
 
  console.time("dumping-response-header-"+count);
  for (var i = 0; i < count; i++) {
    var b = header.toBuffer();
  }
  console.timeEnd("dumping-response-header-"+count);


  var fs = require('fs'),
    p = require('path');
  var hs = JSON.parse(fs.readFileSync(p.resolve(__dirname, "./example-headers.json")));

  buff = new Buffer(hs.request);
  console.time("parsing-request-header-"+count);
  for (var i = 0; i < count; i++) {
    var header = new HttpHeader(buff);
  }
  console.timeEnd("parsing-request-header-"+count);

  header.set('uri', '/highway/to/hell');
  header.set('method', 'POST');

  console.time("dumping-request-"+count);
  for (var i = 0; i < count; i++) {
    var b = header.toBuffer();
  }
  console.timeEnd("dumping-request-"+count); 

  console.log("-Request----------")
  console.log(header.toBuffer().toString().replace(" ", "_"));
  console.log("------------------")


  buff = new Buffer(hs.response);
  console.time("parsing-response-"+count);
  for (var i = 0; i < count; i++) {
    var header = new HttpHeader(buff);
  }
  console.timeEnd("parsing-response-"+count);

  header.set('code', 418);
  header.set('reason', "I'm a teapot");

  
  console.time("dumping-response-"+count);
  for (var i = 0; i < count; i++) {
    var b = header.toBuffer();
  }
  console.timeEnd("dumping-response-"+count); 

  console.log("-Response---------")
  console.log(header.toBuffer().toString());
  console.log("------------------")
}

test();
